com.pivotal.gemfirexd.internal.client.net

## Class NetXAResource

- java.lang.Object
- - com.pivotal.gemfirexd.internal.client.net.NetXAResource

All Implemented Interfaces:
  XAResource

    public class NetXAResource
    extends Object
    implements XAResource

### Field Summary

Fields
`static int` `ACTIVE_ONLY`
`SqlException` `exceptionsOnXA`
`protected boolean` `ignoreMe_`
`static int` `INITIAL_CALLINFO_ELEMENTS`
`int` `nextElement`
`protected NetXAResource` `nextSameRM_`
`static ClientXid` `nullXid`
`static int` `RECOVER_XID_ARRAY_LENGTH`
`protected int` `sameRMGroupIndex_`
`static int` `TMTIMEOUT`
`static int` `XA_NULL_XID`
`static int` `XAFUNC_COMMIT`
`static int` `XAFUNC_END`
`static int` `XAFUNC_FORGET`
`static int` `XAFUNC_NONE`
`static int` `XAFUNC_PREPARE`
`static int` `XAFUNC_RECOVER`
`static int` `XAFUNC_ROLLBACK`
`static int` `XAFUNC_START`
`static String` `XAFUNCSTR_COMMIT`
`static String` `XAFUNCSTR_END`
`static String` `XAFUNCSTR_FORGET`
`static String` `XAFUNCSTR_NONE`
`static String` `XAFUNCSTR_PREPARE`
`static String` `XAFUNCSTR_RECOVER`
`static String` `XAFUNCSTR_ROLLBACK`
`static String` `XAFUNCSTR_START`
`protected static Vector` `xaResourceSameRMGroup_`

### Fields inherited from interface javax.transaction.xa.XAResource

`TMENDRSCAN, TMFAIL, TMJOIN, TMNOFLAGS, TMONEPHASE, TMRESUME, TMSTARTRSCAN, TMSUCCESS, TMSUSPEND, XA_OK, XA_RDONLY`

### Constructor Summary

Constructors
Constructor and Description
`NetXAResource(XAConnection xaconn, int rmId, String userId, String password, NetXAConnection conn)`

### Method Summary

Methods
`void` `addSpecialRegisters(String s)`
`void` `commit(Xid xid, boolean onePhase)`
`void` `end(Xid xid, int flags)` Ends the work performed on behalf of a transaction branch.
`void` `forget(Xid xid)` Tell the resource manager to forget about a heuristically (MANUALLY) completed transaction branch.
`List` `getSpecialRegisters()`
`int` `getTransactionTimeout()` Obtain the current transaction timeout value set for this XAResource instance.
`void` `initForReuse()`
`boolean` `isSameRM(XAResource xares)`
`boolean` `keepCurrentIsolationLevel()`
`int` `prepare(Xid xid)` Ask the resource manager to prepare for a transaction commit of the transaction specified in xid.
`Xid[]` `recover(int flag)` Obtain a list of prepared transaction branches from a resource manager.
`protected void` `removeXaresFromSameRMchain()`
`void` `rollback(Xid xid)` Inform the resource manager to roll back work done on behalf of a transaction branch
`void` `setKeepCurrentIsolationLevel(boolean flag)`
`boolean` `setTransactionTimeout(int seconds)` Set the current transaction timeout value for this XAResource instance.
`void` `start(Xid xid, int flags)` Start work on behalf of a transaction branch specified in xid
`protected void` `throwXAException(int rc)`
`protected void` `throwXAException(int rc, boolean resetFlag)`
`protected int` `xaRetValErrorAccumSQL(NetXACallInfo callInfo, int currentRC)`
`static boolean` `xidsEqual(Xid xid1, Xid xid2)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### TMTIMEOUT

    public static final int TMTIMEOUT

See Also:
  Constant Field Values

#### ACTIVE_ONLY

    public static final int ACTIVE_ONLY

See Also:
  Constant Field Values

#### XA_NULL_XID

    public static final int XA_NULL_XID

See Also:
  Constant Field Values

#### INITIAL_CALLINFO_ELEMENTS

    public static final int INITIAL_CALLINFO_ELEMENTS

See Also:
  Constant Field Values

#### RECOVER_XID_ARRAY_LENGTH

    public static final int RECOVER_XID_ARRAY_LENGTH

See Also:
  Constant Field Values

#### nullXid

    public static final ClientXid nullXid

#### XAFUNC_NONE

    public static final int XAFUNC_NONE

See Also:
  Constant Field Values

#### XAFUNC_COMMIT

    public static final int XAFUNC_COMMIT

See Also:
  Constant Field Values

#### XAFUNC_END

    public static final int XAFUNC_END

See Also:
  Constant Field Values

#### XAFUNC_FORGET

    public static final int XAFUNC_FORGET

See Also:
  Constant Field Values

#### XAFUNC_PREPARE

    public static final int XAFUNC_PREPARE

See Also:
  Constant Field Values

#### XAFUNC_RECOVER

    public static final int XAFUNC_RECOVER

See Also:
  Constant Field Values

#### XAFUNC_ROLLBACK

    public static final int XAFUNC_ROLLBACK

See Also:
  Constant Field Values

#### XAFUNC_START

    public static final int XAFUNC_START

See Also:
  Constant Field Values

#### XAFUNCSTR_NONE

    public static final String XAFUNCSTR_NONE

See Also:
  Constant Field Values

#### XAFUNCSTR_COMMIT

    public static final String XAFUNCSTR_COMMIT

See Also:
  Constant Field Values

#### XAFUNCSTR_END

    public static final String XAFUNCSTR_END

See Also:
  Constant Field Values

#### XAFUNCSTR_FORGET

    public static final String XAFUNCSTR_FORGET

See Also:
  Constant Field Values

#### XAFUNCSTR_PREPARE

    public static final String XAFUNCSTR_PREPARE

See Also:
  Constant Field Values

#### XAFUNCSTR_RECOVER

    public static final String XAFUNCSTR_RECOVER

See Also:
  Constant Field Values

#### XAFUNCSTR_ROLLBACK

    public static final String XAFUNCSTR_ROLLBACK

See Also:
  Constant Field Values

#### XAFUNCSTR_START

    public static final String XAFUNCSTR_START

See Also:
  Constant Field Values

#### nextElement

    public int nextElement

#### xaResourceSameRMGroup_

    protected static Vector xaResourceSameRMGroup_

#### sameRMGroupIndex_

    protected int sameRMGroupIndex_

#### nextSameRM_

    protected NetXAResource nextSameRM_

#### ignoreMe_

    protected boolean ignoreMe_

#### exceptionsOnXA

    public SqlException exceptionsOnXA

### Constructor Detail

#### NetXAResource

    public NetXAResource(XAConnection xaconn,
                 int rmId,
                 String userId,
                 String password,
                 NetXAConnection conn)

### Method Detail

#### commit

    public void commit(Xid xid,
              boolean onePhase)
                throws XAException

Specified by:
  `commit` in interface `XAResource`
Throws:
  `XAException`

#### end

    public void end(Xid xid,
           int flags)
             throws XAException

Ends the work performed on behalf of a transaction branch. The resource manager dissociates the XA resource from the transaction branch specified and let the transaction be completed.

If TMSUSPEND is specified in flags, the transaction branch is temporarily suspended in incomplete state. The transaction context is in suspened state and must be resumed via start with TMRESUME specified.

If TMFAIL is specified, the portion of work has failed. The resource manager may mark the transaction as rollback-only

If TMSUCCESS is specified, the portion of work has completed successfully.

Specified by:
  `end` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier that is the same as what was used previously in the start method.
  `flags` - One of TMSUCCESS, TMFAIL, or TMSUSPEND
Throws:
  `XAException` - An error has occurred. Possible XAException values are XAER_RMERR, XAER_RMFAILED, XAER_NOTA, XAER_INVAL, XAER_PROTO, or XA_RB*.

#### forget

    public void forget(Xid xid)
                throws XAException

Tell the resource manager to forget about a heuristically (MANUALLY) completed transaction branch.

Specified by:
  `forget` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier
Throws:
  `XAException` - An error has occurred. Possible exception values are XAER_RMERR, XAER_RMFAIL, XAER_NOTA, XAER_INVAL, or XAER_PROTO.

#### getTransactionTimeout

    public int getTransactionTimeout()
                              throws XAException

Obtain the current transaction timeout value set for this XAResource instance. If XAResource.setTransactionTimeout was not use prior to invoking this method, the return value is 0; otherwise, the value used in the previous setTransactionTimeout call is returned.

Specified by:
  `getTransactionTimeout` in interface `XAResource`
Returns:
  the transaction timeout value in seconds. If the returned value is equal to Integer.MAX_VALUE it means no timeout.
Throws:
  `XAException`

#### prepare

    public int prepare(Xid xid)
                throws XAException

Ask the resource manager to prepare for a transaction commit of the transaction specified in xid.

Specified by:
  `prepare` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier
Returns:
  A value indicating the resource manager's vote on the outcome of the transaction. The possible values are: XA_RDONLY or XA_OK. If the resource manager wants to roll back the transaction, it should do so by raising an appropriate XAException in the prepare method.
Throws:
  `XAException` - An error has occurred. Possible exception values are: XA_RB*, XAER_RMERR, XAER_RMFAIL, XAER_NOTA, XAER_INVAL, or XAER_PROTO.

#### recover

    public Xid[] recover(int flag)
                  throws XAException

Obtain a list of prepared transaction branches from a resource manager. The transaction manager calls this method during recovery to obtain the list of transaction branches that are currently in prepared or heuristically completed states.

Specified by:
  `recover` in interface `XAResource`
Parameters:
  `flag` - One of TMSTARTRSCAN, TMENDRSCAN, TMNOFLAGS. TMNOFLAGS must be used when no other flags are set in flags.
Returns:
  The resource manager returns zero or more XIDs for the transaction branches that are currently in a prepared or heuristically completed state. If an error occurs during the operation, the resource manager should raise the appropriate XAException.
Throws:
  `XAException` - An error has occurred. Possible values are XAER_RMERR, XAER_RMFAIL, XAER_INVAL, and XAER_PROTO.

#### rollback

    public void rollback(Xid xid)
                  throws XAException

Inform the resource manager to roll back work done on behalf of a transaction branch

Specified by:
  `rollback` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier
Throws:
  `XAException` - An error has occurred

#### setTransactionTimeout

    public boolean setTransactionTimeout(int seconds)
                                  throws XAException

Set the current transaction timeout value for this XAResource instance. Once set, this timeout value is effective until setTransactionTimeout is invoked again with a different value. To reset the timeout value to the default value used by the resource manager, set the value to zero. If the timeout operation is performed successfully, the method returns true; otherwise false. If a resource manager does not support transaction timeout value to be set explicitly, this method returns false.

Specified by:
  `setTransactionTimeout` in interface `XAResource`
Parameters:
  `seconds` - the transaction timeout value in seconds. Value of 0 means the reasource manager's default value. Value of Integer.MAX_VALUE means no timeout.
Returns:
  true if transaction timeout value is set successfully; otherwise false.
Throws:
  `XAException` - - An error has occurred. Possible exception values are XAER_RMERR, XAER_RMFAIL, or XAER_INVAL.

#### setKeepCurrentIsolationLevel

    public void setKeepCurrentIsolationLevel(boolean flag)

#### keepCurrentIsolationLevel

    public boolean keepCurrentIsolationLevel()

#### start

    public void start(Xid xid,
             int flags)
               throws XAException

Start work on behalf of a transaction branch specified in xid

Specified by:
  `start` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier to be associated with the resource
  `flags` - One of TMNOFLAGS, TMJOIN, or TMRESUME
Throws:
  `XAException` - An error has occurred. Possible exceptions * are XA_RB*, XAER_RMERR, XAER_RMFAIL, XAER_DUPID, XAER_OUTSIDE, XAER_NOTA, XAER_INVAL, or XAER_PROTO.

#### throwXAException

    protected void throwXAException(int rc)
                             throws XAException

Throws:
  `XAException`

#### throwXAException

    protected void throwXAException(int rc,
                        boolean resetFlag)
                             throws XAException

Throws:
  `XAException`

#### isSameRM

    public boolean isSameRM(XAResource xares)
                     throws XAException

Specified by:
  `isSameRM` in interface `XAResource`
Throws:
  `XAException`

#### xidsEqual

    public static boolean xidsEqual(Xid xid1,
                    Xid xid2)

#### getSpecialRegisters

    public List getSpecialRegisters()

#### addSpecialRegisters

    public void addSpecialRegisters(String s)

#### xaRetValErrorAccumSQL

    protected int xaRetValErrorAccumSQL(NetXACallInfo callInfo,
                            int currentRC)

#### removeXaresFromSameRMchain

    protected void removeXaresFromSameRMchain()

#### initForReuse

    public void initForReuse()